#include<stdio.h>
#include<math.h>

#define MAX 202
#define STOS 10000
#define MAXWAY 100000

int droga[MAX][MAX];
char visible[MAX][MAX];
int height[MAX][MAX];
int way[MAX][MAX];

int xa,ya,xb,yb;
int pocz,kon;

struct {
  int x,y,droga;
} stos[STOS];

int pusta() {
  return pocz==kon;
}
    
void pobierz(int &x, int &y, int &droga) {
  x=stos[pocz].x;
  y=stos[pocz].y;
  droga=stos[pocz++].droga;
  
  if(pocz==STOS)
    pocz=0;
}

void dodaj(int x, int y, int droga) {
  stos[kon].x=x;
  stos[kon].y=y;
  stos[kon++].droga=droga;
  
  if(kon==STOS)
    kon=0;
}
    
int vis(int x1,int y1,int x2,int y2)
{
  int z1,z2,k,x,y,z;
  double xd,yd,zd;
  
  z1=height[x1][y1];
  z2=height[x2][y2];
  
  if(x1>x2) {
    int tmp=x1;
    x1=x2;
    x2=tmp;
    tmp=y1;
    y1=y2;
    y2=tmp;
  }
      
  for(k=x1;k<x2;k++) {
    yd=y1+0.5+(y2-y1)*(k-x1+0.5)/(x2-x1);
    y=(int)yd;
    zd=z1+0.5+(z2-z1)*(k-x1+0.5)/(x2-x1);
    z=(int)zd;
    
    printf("%f,%f\n ",yd, zd);
    
    if(floor(yd)!=yd) {
      if(height[k][y]>z||height[k+1][y]>z)
        return 0;
    }	
    else if(y1>y2) {
      if(height[k+1][y]>z||height[k][y-1]>z)
         return 0;
    }
    else if(height[k+1][y-1]>z||height[k][y]>z)
      return 0;
  }      

  if(y1>y2) {
    int tmp=x1;
    x1=x2;
    x2=tmp;
    tmp=y1;
    y1=y2;
    y2=tmp;
  }
    
  for(k=y1;k<y2;k++) {
    xd=x1+0.5+(x2-x1)*(k-y1+0.5)/(y2-y1);
    x=(int)xd;
    zd=z1+0.5+(z2-z1)*(k-y1+0.5)/(y2-y1);
    y=(int)yd;
    if(floor(x)!=x) {
      if(height[x][k]>z||height[x][k+1]>z)
        return 0;
    }	
    else if(x1>x2) {
      if(height[x][k+1]>z||height[x-1][k]>z)
         return 0;
    }
    else if(height[x-1][k+1]>z||height[x][k]>z)
      return 0;
  }      
    
  return 1;
}  

int findway() {
 
  int x,y,droga;

  dodaj(xa,ya,0);
  way[xa][ya]=0;
  
  while(!pusta()) {
    if(way[xb][yb]<MAXWAY)
      return way[xb][yb];
    pobierz(x,y,droga);
    printf("%d %d %d\n",x,y,droga);
    if(height[x][y]+1>=height[x+1][y] && height[x][y]-3<=height[x+1][y] &&
       visible[x+1][y] && droga+1<way[x+1][y]) {
       dodaj(x+1,y,droga+1);
       way[x+1][y]=droga+1;
    }   
    if(height[x][y]+1>=height[x-1][y] && height[x][y]-3<=height[x-1][y] &&
       visible[x-1][y] && droga+1<way[x-1][y]) {
       dodaj(x-1,y,droga+1);
       way[x-1][y]=droga+1;
    }
    if(height[x][y]+1>=height[x][y+1] && height[x][y]-3<=height[x][y+1] &&
       visible[x][y+1] && droga+1<way[x][y+1]) {
       dodaj(x,y+1,droga+1);
       way[x][y+1]=droga+1;
    }
    if(height[x][y]+1>=height[x][y-1] && height[x][y]-3<=height[x][y-1] &&
       visible[x][y-1] && droga+1<way[x][y-1]) {
       dodaj(x,y-1,droga+1);
       way[x][y-1]=droga+1;
    } 
  }
  return -1;
}

int main() {
  int n,i,j;
  
  scanf("%d",&n);
  while(n--) 
  {
    int szer,wys;
    
    scanf("%d%d",&wys,&szer);
    
    printf("%d%d\n",wys,szer);
    
    for(i=0;i<=szer+1;i++)
      visible[0][i]=visible[wys+1][i]=0;
    for(i=0;i<=wys+1;i++)
      visible[i][0]=visible[i][szer+1]=0;
    for(i=1;i<=wys;i++)
      for(j=1;j<=szer;j++) {
        scanf("%d",&height[j][i]);
	way[j][i]=MAXWAY;
      }
    scanf("%d%d%d%d",&ya,&xa,&yb,&xb);  

    printf("%d %d %d %d \n",xa,ya,xb,yb);

    for(i=1;i<=wys;i++)
      for(j=1;j<=szer;j++) {
        visible[j][i]=vis(xa,ya,j,i)|vis(xb,yb,j,i);
	printf("%d:%d ",vis(xa,ya,j,i),vis(xb,yb,j,i));
      }
      
    int wynik;
    if((wynik=findway())>=0)
      printf("The shortest path is %d steps long.\n",wynik);
    else
      printf("Mission impossible.\n");
  }      
return 0;

}